﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;

namespace Routing.Controllers {
    [HandleError]
    public class HomeController : Controller {
        public ActionResult Index(string id) {
            ViewData["Title"] = "Home Page";
            ViewData["Message"] = "Welcome to ASP.NET MVC!";
            ViewData["Id param"] = id;
            
            return View();
        }

        public ActionResult About() {
            ViewData["Title"] = "About Page";

            return View();
        }
        
        // The paramter is converted to type DateTime with no conversion error checks
        public ActionResult DisplayDate(DateTime date)
        {
            ViewData["Date"] = date;
            return View();
        }
        
        // Invalid date params will not be passed in
        public ActionResult DisplayValidDate(DateTime date)
        {
            ViewData["Date"] = date;
            return View();
        }
    }
}
