﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace Routing {
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication {
        public static void RegisterRoutes(RouteCollection routes) {
            
            
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            
            //Shortcut to About, removing the need for the controller
            // http://localhost:port/About

            routes.MapRoute("About",
                            "About",
                            new { controller = "Home", action = "About" });


            // http://localhost:port/Home/DisplayDate/12-12-2008 works
            // http://localhost:por/Home/DisplayDate/12-60-2008 works
            routes.MapRoute("DateParamWithoutConstraints",
                            "{controller}/DisplayDate/{date}",
                            new {controller = "Home", action = "DisplayDate"});


            // http://localhost:port/Home/DisplayValidDate/12-12-2008 works
            // http://localhost:por/Home/DisplayValidDate/12-60-2008 wont match 
            routes.MapRoute("DateParamWithConstraints", 
                            "{controller}/DisplayValidDate/{date}",
                            new {controller = "Home", action = "DisplayValidDate"},
                            new { date = @"^([1-9]|0[1-9]|1[012])[-]([1-9]|0[1-9]|[12][0-9]|3[01])[-][0-9]{4}$" });
                            
                            
            routes.MapRoute(
                "Default",                                              
                "{controller}/{action}/{id}",                          
                new { controller = "Home", action = "Index", id = "" }  
            );


        }

        protected void Application_Start() {
            RegisterRoutes(RouteTable.Routes);
           // RouteDebug.RouteDebugger.RewriteRoutesForTesting(RouteTable.Routes);

        }
    }
}