﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace ConstraintRouting {
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication {
        public static void RegisterRoutes(RouteCollection routes) {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Constraint",
                "{controller}/{action}/{id}",
                new { controller = "Home", action = "Custom", id = "" },
                new { badabing = new ParameterLengthConstraint() });

          
          
          
          
          
          
            
            routes.MapRoute(
                "Default",                                              
                "{controller}/{action}/{id}",                       
                new { controller = "Home", action = "Index", id = "" },
                new { action = new ActionConstraint() }
            );

                

        }

        protected void Application_Start() {
            RegisterRoutes(RouteTable.Routes);
            RouteDebug.RouteDebugger.RewriteRoutesForTesting(RouteTable.Routes);
        }
    }

    internal class ParameterLengthConstraint: IRouteConstraint
    {
        public bool Match(HttpContextBase httpContext, Route route, string parameterName, RouteValueDictionary values, RouteDirection routeDirection)
        {
            if (routeDirection == RouteDirection.IncomingRequest)
            {
                return (values["id"].ToString().Length >= 5);
            }
            return false;
        }
    }








    internal class ActionConstraint : IRouteConstraint {
        public bool Match(HttpContextBase httpContext, Route route, string parameterName, RouteValueDictionary values, RouteDirection routeDirection) {
            
            return !values["action"].ToString().Equals("Custom", StringComparison.InvariantCultureIgnoreCase);
        }
    }


}