﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security;
using System.Security.Principal;
using System.Text;
using System.Web;
using System.Web.Mvc;

namespace HttpAuthentication.Attributes
{
    public class HttpAuthAttribute: ActionFilterAttribute  
    {
        public override void OnActionExecuting(ActionExecutingContext filterContext)
        {
            string authHeader = filterContext.HttpContext.Request.Headers["Authorization"];
            if (!String.IsNullOrEmpty(authHeader))
            { 
                // Parse username and password out of the HTTP headers
                authHeader = authHeader.Substring("Basic".Length).Trim();

                byte[] authHeaderBytes = Convert.FromBase64String(authHeader);

                authHeader = Encoding.UTF7.GetString(authHeaderBytes);

                string userName = authHeader.Split(':')[0];
                string password = authHeader.Split(':')[1];

                // Validate User Logic
                if (userName == password) {
                    filterContext.HttpContext.User =
                        new GenericPrincipal(new GenericIdentity(userName), null);
                    return;
                }
            }

            filterContext.Result = new ContentResult()
            {
                ContentType = "text/html",
                Content = "401 Authentication Failed"

            };
            filterContext.HttpContext.Response.StatusCode = 401;
            filterContext.HttpContext.Response.AppendHeader("WWW-Authenticate", "Basic realm=Secure Area");

        }
    }
}
