﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using Microsoft.Web.Mvc;
using Model;

namespace BindingValues.Controllers {
    public class CustomerController : Controller {
        public ActionResult Index() {

            return View();    
        }


        public ActionResult List()
        {
            CustomerServices customerServices = new CustomerServices(new CustomerDAO());

            return View(customerServices.GetCustomers());
        }

        [AcceptVerbs(HttpVerbs.Get)]
        public ActionResult New()
        {
            Customer customer = new Customer();

            customer.IsActive = true;
            customer.DateOfBirth = DateTime.Today;

            return View(customer);
        }
        
        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult New([Bind(Prefix="")] Customer customer)
        {
            CustomerServices customerServices = new CustomerServices(new CustomerDAO());

            customerServices.Save(customer);

            return RedirectToAction("Index");
        }
        

        [AcceptVerbs(HttpVerbs.Get)]
        public ActionResult Update(int id)
        {
            CustomerServices customerServices = new CustomerServices(new CustomerDAO());

            return View(customerServices.GetCustomerById(id));
        }
        
        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Update(int id, FormCollection form)
        {
            CustomerServices customerServices = new CustomerServices(new CustomerDAO());

            Customer customer = customerServices.GetCustomerById(id);

            try
            {
                // Complex sub-props don't have to be specified as individual..i.e. Name, not Name.NameFirst
                UpdateModel(customer, new[] { "Name", "Title", "Email", "DateOfBirth", "IsActive" });

                customerServices.Save(customer);

                return RedirectToAction("Index");
            }
            catch (Exception)
            {

                return View(customer);                

            }
            
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult UpdateAddress(int id, IList<CustomerAddress> addresses)
        {
            CustomerServices customerServices = new CustomerServices(new CustomerDAO());

            Customer customer = customerServices.GetCustomerById(id);

            customer.Addresses = addresses;

            customerServices.Save(customer);

            return RedirectToAction("Update", new {id});
            
        }
        

    }
}
