﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Html;

namespace Controls.Helpers
{
    public static class HtmlHelperExtensions
    {

        public static string AuthActionLink(this HtmlHelper htmlHelper) {
            if (HttpContext.Current.Request.IsAuthenticated) {
                return htmlHelper.ActionLink("Logout", "Logout", "Account");
            }
            return htmlHelper.ActionLink("Login", "Login", "Account");
        }
    



        public static string AdvancedAuthLink(this HtmlHelper htmlHelper)
        {
            TagBuilder divTag = new TagBuilder("div");
            string user = String.Empty;

            if (HttpContext.Current.Request.IsAuthenticated)
            {
                TagBuilder spanTag = new TagBuilder("span")
                                     {
                                         InnerHtml =
                                             String.Format("[Welcome {0}]  ", HttpContext.Current.User.Identity.Name)
                                     };

                user = spanTag.ToString(TagRenderMode.Normal);
            }

            string link = AuthActionLink(htmlHelper);

            divTag.InnerHtml = user + link;

            return divTag.ToString(TagRenderMode.Normal);

        }


    }
}
