﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Model {
    public class CustomerServices : ICustomerServices
    {
        
        private readonly ICustomerDAO _customerDao;

        
        public CustomerServices(ICustomerDAO customerDao)
        {
            _customerDao = customerDao;
        }

        public Customer Save(Customer customer)
        {
            return _customerDao.Save(customer);
        }
        
        public IList<Customer> GetCustomers()
        {
            return _customerDao.GetCustomers();
        }

        public int GetCustomerCount()
        {
            return _customerDao.GetCustomerCount();
        }
        
        public IList<Customer> GetCustomers(ListOrder order)
        {
            return _customerDao.GetCustomers(order);    
        }
        
        public Customer GetCustomerById(int id)
        {
            return _customerDao.GetCustomerById(id);
        }

        public IList<Customer> GetCustomersByName(string name)
        {
            return _customerDao.GetCustomersByName(name);
        }

        public IList<FlatCustomer> GetFlatCustomer()
        {
            return _customerDao.GetFlatCustomers();
        }
    }
}
